<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Sensor_Driver &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../../_static/doctools.js?v=888ff710"></script>
        <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="Spawner" href="spawner.html" />
    <link rel="prev" title="Dynamics_Scenario" href="dynamics_scenario.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            openPASS
              <img src="../../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../50_scenario_simulation.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../20_components.html">Component View</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../20_components.html#components-in-depth">Components in Depth</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="algorithm_lateral.html">Algorithm_Lateral</a></li>
<li class="toctree-l4"><a class="reference internal" href="algorithm_longitudinal.html">Algorithm_Longitudinal</a></li>
<li class="toctree-l4"><a class="reference internal" href="driver.html">Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_regular_driving.html">Dynamics_RegularDriving</a></li>
<li class="toctree-l4"><a class="reference internal" href="dynamics_scenario.html">Dynamics_Scenario</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Sensor_Driver</a></li>
<li class="toctree-l4"><a class="reference internal" href="spawner.html">Spawner</a></li>
<li class="toctree-l4"><a class="reference internal" href="vehicle.html">VehicleComponents</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../50_scenario_simulation.html">Simulator</a></li>
          <li class="breadcrumb-item"><a href="../20_components.html">Component View</a></li>
      <li class="breadcrumb-item active">Sensor_Driver</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../../_sources/user_guide/sim_user_guide/components/sensor_driver.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="sensor-driver">
<span id="id1"></span><h1>Sensor_Driver<a class="headerlink" href="#sensor-driver" title="Link to this heading"></a></h1>
<p>This module collects and distributes data from the WorldInterface and AgentInterface concerning the own vehicle, traffic rule
and geometry information and surrounding object. It creates a data struct to store the world and agent data of the own vehicle,
traffic rule and geometry information, other objects and surrounding vehicles.</p>
<section id="components-of-the-module">
<h2>Components of the module<a class="headerlink" href="#components-of-the-module" title="Link to this heading"></a></h2>
<p>The information collected by SensorDriver consists of generally four different data structs:</p>
<ul class="simple">
<li><p><a class="reference internal" href="#sensor-driver-own-vehicle-states"><span class="std std-ref">OwnVehicleStates</span></a> includes all information about the vehicle of the driver (e.g. speed, acceleration, …)</p></li>
<li><p><a class="reference internal" href="#sensor-driver-traffic-rule-information"><span class="std std-ref">TrafficRuleInformation</span></a> includes information about the static environment (e.g. traffic signs, lane markings, …)</p></li>
<li><p><a class="reference internal" href="#sensor-driver-geometry-information"><span class="std std-ref">GeometryInformation</span></a> includes information about surrounding lanes that describe its geometric features</p></li>
<li><p><a class="reference internal" href="#sensor-driver-surrounding-objects"><span class="std std-ref">SurroundingObjects</span></a> includes information about objects surrounding the own agent as seen by the driver</p></li>
</ul>
<section id="ownvehiclestates">
<span id="sensor-driver-own-vehicle-states"></span><h3>OwnVehicleStates<a class="headerlink" href="#ownvehiclestates" title="Link to this heading"></a></h3>
<p>The Information of the own vehicle are based on the following general <strong>struct OwnVehicleInformation</strong> :</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Default value</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>absoluteVelocity</p></td>
<td><p>Double</p></td>
<td><p>m/s</p></td>
<td><p>Velocity of agent</p></td>
<td><p>-999</p></td>
</tr>
<tr class="row-odd"><td><p>acceleration</p></td>
<td><p>Double</p></td>
<td><p>m/s²</p></td>
<td><p>Acceleration of agent</p></td>
<td><p>-999</p></td>
</tr>
<tr class="row-even"><td><p>lateralPosition</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>t-coordinate</p></td>
<td><p>-999</p></td>
</tr>
<tr class="row-odd"><td><p>heading</p></td>
<td><p>Double</p></td>
<td><p>rad</p></td>
<td><p>Heading relative to lane</p></td>
<td><p>-999</p></td>
</tr>
<tr class="row-even"><td><p>steeringWheelAngle</p></td>
<td><p>Double</p></td>
<td><p>rad</p></td>
<td><p>Angle of the steering wheel</p></td>
<td><p>-999</p></td>
</tr>
<tr class="row-odd"><td><p>distanceToLaneBoundaryLeft</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Distance between the left front point and the left boundary of the lane it is in</p></td>
<td><p>-999</p></td>
</tr>
<tr class="row-even"><td><p>distanceToLaneBoundaryRight</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Distance between the right front point and the right boundary of the lane it is in</p></td>
<td><p>-999</p></td>
</tr>
<tr class="row-odd"><td><p>collision</p></td>
<td><p>Boolean</p></td>
<td></td>
<td><p>Whether this agent has collided with another object</p></td>
<td><p>false</p></td>
</tr>
</tbody>
</table>
</section>
<section id="trafficruleinformation">
<span id="sensor-driver-traffic-rule-information"></span><h3>TrafficRuleInformation<a class="headerlink" href="#trafficruleinformation" title="Link to this heading"></a></h3>
<p>The struct TrafficRuleInformation contains infrastructure information of surrounding lanes that are used to establish traffic rules.</p>
<p>The general structure is shown in the following table.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>laneLeft</p></td>
<td><p>Data about the lane to left (in driving direction) of the mainLane</p></td>
</tr>
<tr class="row-odd"><td><p>laneEgo</p></td>
<td><p>Data about the lane the where the middle of the front of the agent is (i.e. mainLane)</p></td>
</tr>
<tr class="row-even"><td><p>laneRight</p></td>
<td><p>Data about the lane to right (in driving direction) of the mainLane</p></td>
</tr>
<tr class="row-odd"><td><p>laneMarkingsLeft</p></td>
<td><p>List of lane markings on the left side of mainLane</p></td>
</tr>
<tr class="row-even"><td><p>laneMarkingsRight</p></td>
<td><p>List of lane markings on the right side of mainLane</p></td>
</tr>
<tr class="row-odd"><td><p>laneMarkingsLeftOfLeftLane</p></td>
<td><p>List of lane markings on the left side of lane to the left</p></td>
</tr>
<tr class="row-even"><td><p>laneMarkingsRightOfRightLane</p></td>
<td><p>List of lane markings on the right side of lane to the right</p></td>
</tr>
</tbody>
</table>
<p>The basis for the respective variables is the following general struct <strong>LaneInformationTrafficRules</strong>, which is used to trasport data of a lane concerning traffic rules as seen by the driver.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>trafficSigns</p></td>
<td><p>Vector of all traffic signs valid for this lane inside the visibility distance</p></td>
</tr>
<tr class="row-odd"><td><p>trafficLights</p></td>
<td><p>Vector of all traffic lights valid for this lane inside the visibility distance</p></td>
</tr>
</tbody>
</table>
</section>
<section id="geometryinformation">
<span id="sensor-driver-geometry-information"></span><h3>GeometryInformation<a class="headerlink" href="#geometryinformation" title="Link to this heading"></a></h3>
<p>The struct GeometryInformation contains infrastructure information of surrounding lanes that describe its geometric features.</p>
<p>The general structure is shown in the following table.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>visibilityDistance</p></td>
<td><p>Current maximum visibility distance as specified by the world</p></td>
</tr>
<tr class="row-odd"><td><p>laneLeft</p></td>
<td><p>Data about the lane to left (in driving direction) of the mainLane</p></td>
</tr>
<tr class="row-even"><td><p>laneEgo</p></td>
<td><p>Data about the lane the where the middle of the front of the agent is (i.e. mainLane)</p></td>
</tr>
<tr class="row-odd"><td><p>laneRight</p></td>
<td><p>Data about the lane to right (in driving direction) of the mainLane</p></td>
</tr>
</tbody>
</table>
<p>The basis for the respective variables is the following general struct <strong>LaneInformationGeometry</strong>, which is used to transport data of a lane concerning its geometric features as seen by the driver.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Default value</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>exists</p></td>
<td><p>Boolean</p></td>
<td></td>
<td><p>Whether there is a lane on this position</p></td>
<td><p>false</p></td>
</tr>
<tr class="row-odd"><td><p>curvature</p></td>
<td><p>Double</p></td>
<td><p>1/m</p></td>
<td><p>Curvature at current s position (default if not existing)</p></td>
<td><p>-999</p></td>
</tr>
<tr class="row-even"><td><p>width</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Width at current s position (default if not existing)</p></td>
<td><p>-999</p></td>
</tr>
<tr class="row-odd"><td><p>distanceToEndOfLane</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Distance from current position to the end of the lane or
infinity if the end is farther away than the visibility distance</p></td>
<td><p>-999</p></td>
</tr>
</tbody>
</table>
</section>
<section id="surroundingobjects">
<span id="sensor-driver-surrounding-objects"></span><h3>SurroundingObjects<a class="headerlink" href="#surroundingobjects" title="Link to this heading"></a></h3>
<p>This struct SurroundingObjects contains data of the objects surrounding the own agent as seen by the driver. For all cases mainLaneId is used as own lane.</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>objectFront</p></td>
<td><p>Next object in the same lane</p></td>
</tr>
<tr class="row-odd"><td><p>objectRear</p></td>
<td><p>Closest object behind the agent in the same lane</p></td>
</tr>
<tr class="row-even"><td><p>objectFrontLeft</p></td>
<td><p>Next object in the lane to the left</p></td>
</tr>
<tr class="row-odd"><td><p>objectRearLeft</p></td>
<td><p>Closest object behind the agent in the lane to the left</p></td>
</tr>
<tr class="row-even"><td><p>objectFrontRight</p></td>
<td><p>Next object in the lane to the right</p></td>
</tr>
<tr class="row-odd"><td><p>objectRearRight</p></td>
<td><p>Closest object behind the agent in the lane to the right</p></td>
</tr>
</tbody>
</table>
<p>The basis for the respective variables is the following general struct <strong>ObjectInformation</strong>, which is used to transport data of an object as seen by the driver:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Variable</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Unit</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Default value</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>id</p></td>
<td><p>Integer</p></td>
<td></td>
<td><p>Id of the object</p></td>
<td><p>-1 (not existing)</p></td>
</tr>
<tr class="row-odd"><td><p>exist</p></td>
<td><p>Boolean</p></td>
<td></td>
<td><p>False if there is no object in this position</p></td>
<td><p>false</p></td>
</tr>
<tr class="row-even"><td><p>isStatic</p></td>
<td><p>Boolean</p></td>
<td></td>
<td><p>True if stationary object, false if agent</p></td>
<td><p>false</p></td>
</tr>
<tr class="row-odd"><td><p>absoluteVelocity</p></td>
<td><p>Double</p></td>
<td><p>m/s</p></td>
<td><p>Absolute velocity of the agent</p></td>
<td><p>-999 (object is not an agent)</p></td>
</tr>
<tr class="row-even"><td><p>acceleration</p></td>
<td><p>Double</p></td>
<td><p>m/s²</p></td>
<td><p>Acceleration of the agent</p></td>
<td><p>-999 (object is not an agent)</p></td>
</tr>
<tr class="row-odd"><td><p>heading</p></td>
<td><p>Double</p></td>
<td><p>rad</p></td>
<td><p>Heading relative to the street</p></td>
<td><p>-999 (not existing)</p></td>
</tr>
<tr class="row-even"><td><p>length</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Length of object</p></td>
<td><p>-999 (not existing)</p></td>
</tr>
<tr class="row-odd"><td><p>width</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Width of object</p></td>
<td><p>-999 (not existing)</p></td>
</tr>
<tr class="row-even"><td><p>height</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Heigth of object</p></td>
<td><p>-999 (not existing)</p></td>
</tr>
<tr class="row-odd"><td><p>relativeLongitudinalDistance</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Relative distance along the road (i.e. in direction s) between own agent and object</p></td>
<td><p>-999 (not existing)</p></td>
</tr>
<tr class="row-even"><td><p>relativeLateralDistance</p></td>
<td><p>Double</p></td>
<td><p>m</p></td>
<td><p>Relative distance at right angle to the road (i.e in direction t) between own agent and object</p></td>
<td><p>-999 (not existing)</p></td>
</tr>
</tbody>
</table>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="dynamics_scenario.html" class="btn btn-neutral float-left" title="Dynamics_Scenario" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="spawner.html" class="btn btn-neutral float-right" title="Spawner" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>